// Persistence of Vision Ray Tracer Scene Description File
// File: iso_csg_test10.pov
// Vers: 3.5
// Desc: iso_csg eblob macros demo
// Date: Jun. 2003 
// Auth: Christoph Hormann
//

// ----------------------------------------

#version 3.5;

global_settings {
  assumed_gamma 1 
}

background { color <0.750,0.500,0.300> }

camera {
  location <0.6,0.7,-1>*3.5
  look_at  <-0.1,-0.2,0>
  right (4/3)*x
  angle 36
}

light_source {
  <1000, 3500, -5000>
  color rgb 1.2
}      

#include "iso_rcsg.inc"

#declare fn_Array=array[8]

#declare fn_Array[0]=IC_Triangle(<0,0.1,0>, y, <0, 1, 0.5>, 0.05)
#declare fn_Array[1]=IC_Rotate(IC_Triangle(<0,0.1,0>, y, <0, 1, 0.5>, 0.05), 45*z)
#declare fn_Array[2]=IC_Rotate(IC_Triangle(<0,0.1,0>, y, <0, 1, 0.5>, 0.05), 90*z)
#declare fn_Array[3]=IC_Rotate(IC_Triangle(<0,0.1,0>, y, <0, 1, 0.5>, 0.05), 135*z)
#declare fn_Array[4]=IC_Rotate(IC_Triangle(<0,0.1,0>, y, <0, 1, 0.5>, 0.05), 180*z)
#declare fn_Array[5]=IC_Rotate(IC_Triangle(<0,0.1,0>, y, <0, 1, 0.5>, 0.05), 225*z)
#declare fn_Array[6]=IC_Rotate(IC_Triangle(<0,0.1,0>, y, <0, 1, 0.5>, 0.05), 270*z)
#declare fn_Array[7]=IC_Rotate(IC_Triangle(<0,0.1,0>, y, <0, 1, 0.5>, 0.05), 315*z)

#declare fn_YY=IC_Merge_Array(fn_Array)

#declare fn_Shovels=
  function {    
    fn_YY(f_r(x, y, 0)*sin(f_th(x, 0, y)+0.5*pow(f_r(x, y, 0), 2)+1.5*pow(0.55-z, 2)),
          f_r(x, y, 0)*cos(f_th(x, 0, y)+0.5*pow(f_r(x, y, 0), 2)+1.5*pow(0.55-z, 2)),
          z)
  }

#declare fn_Center=IC_Threshold(IC_Cone(-0.1*z, 0.2, 0.3*z, 0.15), 0.05)

#declare fn_XX=IC_EBlob_Linear(IC_EBlob2(fn_Shovels, fn_Center, 0.0005), 0.0005)
//#declare fn_XX=IC_Merge2(fn_Shovels, fn_Center)

#declare Obj_Iso=
isosurface {

  function{ fn_XX(x, y, z) }

  max_gradient 2

  accuracy 0.001
  contained_by { box { <-1.1, -1.1, -0.19>, <1.1, 1.1, 0.6> } }

  translate 0.19*z
  rotate 180*y

}

// ----------------------------------------


difference {
  object { Obj_Iso }
  union {
    cone { z*0.04, 0.1-0.025, -z*0.04, 0.1+0.055 }
    cone { z*(0.35+0.19-0.04), 0.1-0.025, z*(0.35+0.19+0.04), 0.1+0.055 }
    cylinder { -z, z, 0.1 }
    rotate 180*y
    texture {
      pigment { rgb <1, 0.2, 0.2> }
      finish {           
        specular 0.15
      }         
    }
  }
  texture {
    pigment { rgb <0, 0.2, 1.1> }   
    finish {           
      specular 0.15
    }
  }     
}
  

